<?php
class ControllerExtensionPaymentBirb extends Model {
	private $error = array();
	public function index() {
		$this->load->language('extension/payment/birb');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		$this->load->model('extension/payment/birb');
		$this->birbError = '';
		$data['payment_birb_error'] = '';
		$Verify = true;
		if (($this->request->server['REQUEST_METHOD'] == 'POST')){
			$Verify=$this->Verify($this->request->post);
				
			$data['payment_birb_error'] = $this->birbError;
		}
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate() && $Verify) {
			
			
			$s =$this->model_setting_setting->editSetting('payment_birb', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['payable'])) {
			$data['error_payable'] = $this->error['payable'];
		} else {
			$data['error_payable'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/birb', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/birb', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		$method_data = array();

		if (isset($this->request->post['payment_birb_address'])) {
			$data['payment_birb_address'] = $this->request->post['payment_birb_address'];
		} else {
			$data['payment_birb_address'] = $this->config->get('payment_birb_address');
		}
		if (isset($this->request->post['payment_busd_address'])) {
					$data['payment_busd_address'] = $this->request->post['payment_busd_address'];
				} else {
					$data['payment_busd_address'] = $this->config->get('payment_busd_address');
				}

		if (isset($this->request->post['payment_birb_apikey'])) {
			$data['payment_birb_apikey'] = $this->request->post['payment_birb_apikey'];
		} else {
			$data['payment_birb_apikey'] = $this->config->get('payment_birb_apikey');
		}

		if (isset($this->request->post['payment_birb_apisecret'])) {
			$data['payment_birb_apisecret'] = $this->request->post['payment_birb_apisecret'];
		} else {
			$data['payment_birb_apisecret'] = $this->config->get('payment_birb_apisecret');
		}
		if (isset($this->request->post['payment_birb_status'])) {
			$data['payment_birb_status'] = $this->request->post['payment_birb_status'];
		} else {
			$data['payment_birb_status'] = $this->config->get('payment_birb_status');
		}
		if (isset($this->request->post['payment_birb_url'])) {
			$data['payment_birb_url'] = $this->request->post['payment_birb_url'];
		} else {
			$data['payment_birb_url'] = $this->config->get('payment_birb_url');
		}
		if (isset($this->request->post['payment_birb_show'])) {
			$data['payment_birb_show'] = $this->request->post['payment_birb_show'];
		} else {
			$data['payment_birb_show'] = $this->config->get('payment_birb_show');
		}
		if (isset($this->request->post['payment_birb_busd_show'])) {
			$data['payment_birb_busd_show'] = $this->request->post['payment_birb_busd_show'];
		} else {
			$data['payment_birb_busd_show'] = $this->config->get('payment_birb_busd_show');
		}
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/birb', $data));
		
	}
	
	public function install() {
		$this->load->model('extension/payment/birb');
		$this->model_extension_payment_birb->install();
	}

	public function uninstall() {
		$this->load->model('extension/payment/birb');
		$this->model_extension_payment_birb->uninstall();
	}
	protected function validate() {
		 if (!$this->user->hasPermission('modify', 'extension/payment/birb')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['payment_birb_apikey']) {
			$this->error['payable'] = $this->language->get('error_apikey');
		}
		if (!$this->request->post['payment_birb_apisecret']) {
					$this->error['payable'] = $this->language->get('error_apisecret');
				}
		
		if (!$this->request->post['payment_birb_address']) {
					$this->error['payable'] = $this->language->get('error_address');
				}
		if (!$this->request->post['payment_birb_url']) {
					$this->error['payable'] = $this->language->get('error_url');
				}
		
				return !$this->error;
		
	}
	private function Verify($data){
		$checkCredentials = $this->loginAPI($data);		
		if($checkCredentials->status ==false){
			$this->birbError ='Api credentials invalid Login failed in Birb';
			return false;
		}
		else{
				return true;
		}
	}
	private function sendCurl($url,$data,$header){
		
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_HTTPHEADER,$header );
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);

		$response = curl_exec($ch);
		
		if (curl_errno($ch) != CURLE_OK) {
			curl_close($ch);
			 $toReturn = new stdClass();
			 $toReturn->status=false;
			 $toReturn->data='Request failed';
			return $toReturn;
		} else {
			
			if($this->isJson($response)){
				return json_decode($response);				
			}
			
		}
		
		$toReturn = new stdClass();
		 $toReturn->status=false;
		 $toReturn->data='Request failed';
		return $toReturn;
	}
	private function loginAPI($data){
		
		
			$apiKey=$data['payment_birb_apikey'];
			$apiSecret=$data['payment_birb_apisecret'];
			$url=$data['payment_birb_url'].'api/deep/login';			
			$data= array(
					'apiKey'=>$apiKey,	
					'apiSecret'=>$apiSecret,	
					);
			$header= array("Content-Type: application/json");	
			return $this->sendCurl($url, $data,$header);
				
		
	}
	private function isJson($string) {
	 json_decode($string);
	 return (json_last_error() == JSON_ERROR_NONE);
	}
}
