<?php

class ModelExtensionPaymentBirb extends Model {

	public function install() {
		$this->db->query("
			CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "birb_order` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `order_id` int(11) NOT NULL,
			  `birbId` VARCHAR(244) NOT NULL,
			  `created` DATETIME NOT NULL,
			  `modified` DATETIME NOT NULL,
			  `total` DECIMAL( 10, 2 ) NOT NULL,
			  `coin` CHAR(33) NOT NULL,
			  `currency` CHAR(33) NOT NULL,
			  `transaction_id` VARCHAR(24)  DEFAULT NULL,
			  `debug_data` TEXT,
			  `platformId` VARCHAR(244) DEFAULT NULL,
			  `payment` BOOLEAN  DEFAULT FALSE,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;");

		$this->db->query("
			CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "birb_transactions` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `order_id` VARCHAR(244) NOT NULL,
				`created` DATETIME NOT NULL,
			  `modified` DATETIME NOT NULL,
				`debug_data` TEXT, 
				`total` VARCHAR(244) NOT NULL, 
				`to` VARCHAR(244) NOT NULL,
				`from` VARCHAR(244) NOT NULL,
				`fromaddress` VARCHAR(244) NOT NULL,
				`hash`VARCHAR(244) NOT NULL,
				`coin` VARCHAR(244) NOT NULL,
				`platformId` VARCHAR(244) NOT NULL,
				`birbId` VARCHAR(244) NOT NULL ,
				`transaction_id` VARCHAR(244) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;");

		$this->db->query("
			CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "birb_address` (
			  `id` INT(11) NOT NULL AUTO_INCREMENT,
			  `user_id` INT(11) NOT NULL,
			  `order_id` INT(11) NOT NULL,
			  `address` VARCHAR(50) NOT NULL,
			  `email` VARCHAR(50) NOT NULL,
			  `api_data` TEXT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;");
	}

	public function uninstall() {
		//$this->model_setting_setting->deleteSetting($this->request->get['extension']);
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "birb_order`;");
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "birb_transactions`;");
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "birb_address`;");
	}
	public function getBirbOrder($order_id) {
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "birb_order WHERE order_id = '" . (int)$order_id . "'");

		return $query->rows;
	}
	public function getTransaction($order_id) {
		//var_dump($order_id);die;
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "birb_transactions WHERE order_id = '" . (int)$order_id . "' ORDER BY id DESC");
		//var_dump($query->rows);die;
		return $query->rows;
	}

	

	public function getCards($customer_id) {

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "eway_card WHERE customer_id = '" . (int)$customer_id . "'");

		$card_data = array();

		$this->load->model('account/address');

		foreach ($query->rows as $row) {

			$card_data[] = array(
				'card_id' => $row['card_id'],
				'customer_id' => $row['customer_id'],
				'token' => $row['token'],
				'digits' => '**** ' . $row['digits'],
				'expiry' => $row['expiry'],
				'type' => $row['type'],
			);
		}
		return $card_data;
	}

	


	

}