<?php
class ControllerExtensionPaymentBirb extends Controller
{

	public function index()
	{
		$this->load->language('extension/payment/birb');
		$data['bank'] = '';

		$this->loginAPI();
		$this->load->model('checkout/order');
		return $this->load->view('extension/payment/birb', $data);
	}
	private function isJson($string)
	{
		json_decode($string);
		return (json_last_error() == JSON_ERROR_NONE);
	}


	private function loginAPI()
	{
		$cartData = $this->session->data;
		if (!array_key_exists('apiToken', $cartData)) {
			$apiKey = $this->config->get('payment_birb_apikey');
			$apiSecret = $this->config->get('payment_birb_apisecret');

			$url = 'api/deep/login';
			$data = array(
				'apiKey' => $apiKey,
				'apiSecret' => $apiSecret,
			);
			$header = array("Content-Type: application/json");
			$response = $this->sendCurl($url, $data, $header);

			if ($response->status) {
				$this->session->data['apiToken'] = $response->data->platform->token;
				return true;
			}
			return false;
		}
		return true;
	}
	public function sendCurl($url, $data, $header)
	{
		$baseUrl = $this->config->get('payment_birb_url');
		$ch = curl_init($baseUrl . $url);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);

		$response = curl_exec($ch);

		if (curl_errno($ch) != CURLE_OK) {
			curl_close($ch);
			$toReturn = new stdClass();
			$toReturn->status = false;
			$toReturn->data = 'Request failed';
			return $toReturn;
		} else {

			if ($this->isJson($response)) {
				return json_decode($response);
			}
		}

		$toReturn = new stdClass();
		$toReturn->status = false;
		$toReturn->data = 'Request failed';
		return $toReturn;
	}
	private function createOrder($data)
	{
		$cartData = $this->session->data;

		if (!array_key_exists('apiToken', $cartData)) {

			$st = $this->loginAPI();
			if (!$st) {
				$object = new STDClass();
				$object->status = false;
				$object->data = 'Login Failed In Birb Pay';
				return $object;
			}
		}

		$header = array(
			"Authorization: Token " . $this->session->data['apiToken'],
			"Content-Type: application/json",
		);

		$url = 'payment/order';
		$response = $this->sendCurl($url, $data, $header);
		return $response;
	}
	public function confirm()
	{

		$json = array();
		$json['status'] = false;
		$json['error'] = '';
		
		if ($this->session->data['payment_method']['code'] == 'birb') {

			$this->load->language('extension/payment/birb');

			$this->load->model('checkout/order');
			$this->load->model('extension/payment/birb');
			$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
			$products = $this->cart->getProducts();
			$wallet_address = $this->config->get('payment_birb_address');

			$order_info['storeOrderId'] = $order_info['order_id'];
			$order_info['merchant_address'] = $wallet_address;
			$order_info['get_total'] = $order_info['total'];
			$items = [];
			foreach ($products as  $item) {
				// Get the product name
				$item_id = $item['product_id'];
				$product_name = $item['name'];
				$item_quantity = $item['quantity'];
				$item_total = $item['total'];
				$items[$item_id] = ["name" => $product_name, "qty" => $item_quantity, 'price' => $item_total];
			}
			$order_info['fullOrder'] = $items;
			$order_info['cancelUrl'] = $order_info['store_url'] . 'index.php?route=extension/payment/birb/failed&';
			$order_info['successUrl'] = $order_info['store_url'] . 'index.php?route=extension/payment/birb/completed&';
			if (isset($this->request->post['currency'])) {
				$this->session->data['crypto_currency']=$this->request->post['currency'];

			} else {
				$this->session->data['crypto_currency']='birb';
			}
			$order_info['currency'] = $this->session->data['crypto_currency'];
			
			$isOrderCreated = $this->createOrder($order_info);

			if ($isOrderCreated->status == true) {
				$this->model_extension_payment_birb->addOrder((array)$isOrderCreated->data);
				$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_birb_order_status_id'), 'birb_pending', true);
				$json['status'] = true;
				// $json['order_info']=$order_info;
				$json['redirect'] = $this->config->get('payment_birb_url') . 'payment/confirm/' . $isOrderCreated->data->_id;
			} else {
				$json['status'] = false;
				// $json['order_info']=$order_info;
				$json['error'] = $isOrderCreated->data;
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
	public function failed()
	{
		if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
			$base = $this->config->get('config_ssl');
		} else {
			$base = $this->config->get('config_url');
		}
		if (isset($_GET['orderId'])) {


			$this->loginAPI();
			$header = array(
				"Authorization: Token " . $this->session->data['apiToken'],
				"Content-Type: application/json",
			);

			$url = 'payment/order/status/' . $_GET['orderId'];
			$response = $this->sendCurl($url, [], $header);
			if ($response->status == true) {
				$this->load->model('checkout/order');

				$storeOrderId = $response->storeOrderId;
				$order_info = $this->model_checkout_order->getOrder($storeOrderId);
				if ($order_info) {
					$payment = $response->payment ? 5 : 14;
					$this->db->query("UPDATE " . DB_PREFIX . "order SET order_status_id = '" . $payment . "' WHERE order_id = '" . (int)$storeOrderId . "'");


					header('Location: ' . $base . '?route=checkout/success');
				}

				header('Location: ' . $base . '?route=checkout/failure');
			}
		} else {
			header('Location: ' . $base . '?route=checkout/failure');
		}
	}
	public function completed()
	{
		if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
			$base = $this->config->get('config_ssl');
		} else {
			$base = $this->config->get('config_url');
		}
		if (isset($_GET['orderId'])) {


			$this->loginAPI();
			$header = array(
				"Authorization: Token " . $this->session->data['apiToken'],
				"Content-Type: application/json",
			);

			$url = 'payment/order/status/' . $_GET['orderId'];
			
			$response = $this->sendCurl($url, [], $header);
			
			if ($response->status == true) {
				$this->load->model('checkout/order');
				$storeOrderId = $response->storeOrderId;
				$order_info = $this->model_checkout_order->getOrder($storeOrderId);

				if ($order_info) {
					$payment = $response->payment ? 5 : 14;
					$this->db->query("UPDATE " . DB_PREFIX . "order SET order_status_id = '" . $payment . "' WHERE order_id = '" . (int)$storeOrderId . "'");
					//$this->updateOrder($response,$_GET['orderId']);

					if ($response->payment) {

						$this->updateOrder($response, $_GET['orderId']);
						header('Location: ' . $base . '?route=checkout/success');
						exit;
					}
					header('Location: ' . $base . '?route=checkout/success');
					exit;
				}

				header('Location: ' . $base . '?route=checkout/failure');
			}
			die;
		} else {
			header('Location: ' . $base . '?route=checkout/failure');
		}
	}



	private function updateOrder($orderResponse, $birbId)
	{

		$this->load->model('extension/payment/birb');
		$this->model_extension_payment_birb->updateOrder($orderResponse->storeOrderId);

		$header = array(
			"Authorization: Token " . $this->session->data['apiToken'],
			"Content-Type: application/json",
		);

		$url = 'transaction/' . $birbId;

		$data = array('address' => $this->config->get('payment_birb_address'));
		//var_dump($data);die;
		$response = $this->sendCurl($url, $data, $header);

		if ($response->status == true) {
			$order_data = null;
			$order_data = $response->order;
			// var_dump($order_data);
			if ($order_data && $order_data->storeOrderId) {
				
				$this->model_extension_payment_birb->addTransaction($order_data);
			}
			if($response->verify){
				$this->model_extension_payment_birb->updateOrderStatus($order_data->storeOrderId,5);
			} else {
				$this->model_extension_payment_birb->updateOrderStatus($order_data->storeOrderId,1);
			}
		} else {
			// $this->model_extension_payment_birb->updateOrderStatus($storeOrderId,1);
		}
	}
}
